'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var components = require('@tarojs/components');
var React = require('react');
var Taro = require('@tarojs/taro');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var Taro__default = /*#__PURE__*/_interopDefaultLegacy(Taro);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

/** @deprecated */
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

// do not edit .js files directly - edit src/index.jst



var fastDeepEqual = function equal(a, b) {
  if (a === b) return true;

  if (a && b && typeof a == 'object' && typeof b == 'object') {
    if (a.constructor !== b.constructor) return false;

    var length, i, keys;
    if (Array.isArray(a)) {
      length = a.length;
      if (length != b.length) return false;
      for (i = length; i-- !== 0;)
        if (!equal(a[i], b[i])) return false;
      return true;
    }



    if (a.constructor === RegExp) return a.source === b.source && a.flags === b.flags;
    if (a.valueOf !== Object.prototype.valueOf) return a.valueOf() === b.valueOf();
    if (a.toString !== Object.prototype.toString) return a.toString() === b.toString();

    keys = Object.keys(a);
    length = keys.length;
    if (length !== Object.keys(b).length) return false;

    for (i = length; i-- !== 0;)
      if (!Object.prototype.hasOwnProperty.call(b, keys[i])) return false;

    for (i = length; i-- !== 0;) {
      var key = keys[i];

      if (!equal(a[key], b[key])) return false;
    }

    return true;
  }

  // true if both NaN, false otherwise
  return a!==a && b!==b;
};

var pipe = function () {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return function (value) {
        return __spread(fns).reduce(function (result, fn) {
            return fn(result);
        }, value);
    };
};
var getSafeIndex = function (index, maxIndex, minIndex) {
    if (minIndex === void 0) { minIndex = 0; }
    return pipe(function (value) { return Math.max(value, minIndex); }, function (value) { return Math.min(value, maxIndex); })(index);
};
var getTargetIndex = function (toIndex, maxIndex, minIndex) {
    if (minIndex === void 0) { minIndex = 0; }
    if (toIndex > maxIndex)
        return (toIndex % maxIndex) - 1;
    if (toIndex < minIndex)
        return maxIndex + (toIndex % maxIndex) + 1;
    return toIndex;
};
var getStepValue = function (fromIndex, toIndex, maxIndex, loop) {
    if (maxIndex === void 0) { maxIndex = 1; }
    if (loop === void 0) { loop = true; }
    if (fromIndex === toIndex)
        return 0;
    if (loop) {
        if (fromIndex === 0 && toIndex === maxIndex)
            return -1;
        if (toIndex === 0 && fromIndex === maxIndex)
            return 1;
    }
    return toIndex - fromIndex;
};
var sleep = function (timeout) {
    if (timeout === void 0) { timeout = 300; }
    return new Promise(function (r) {
        setTimeout(r, timeout);
    });
};

var Scheduler = /** @class */ (function () {
    function Scheduler(_a) {
        var _b = _a.dataCount, dataCount = _b === void 0 ? 0 : _b, _c = _a.defaultDataIndex, defaultDataIndex = _c === void 0 ? 0 : _c, _d = _a.minCount, minCount = _d === void 0 ? 3 : _d, _e = _a.loop, loop = _e === void 0 ? false : _e, onDataIndexChange = _a.onDataIndexChange, onRecompute = _a.onRecompute, onRestart = _a.onRestart, onContainerIndexChange = _a.onContainerIndexChange;
        this.group = [];
        this.indexMapping = new Map();
        this.containerIndex = 0;
        this.dataCount = dataCount;
        this.dataIndex = defaultDataIndex;
        this.minCount = minCount;
        this.loop = loop;
        this.onDataIndexChange = onDataIndexChange;
        this.onRecompute = onRecompute;
        this.onRestart = onRestart;
        this.onContainerIndexChange = onContainerIndexChange;
    }
    Object.defineProperty(Scheduler.prototype, "maxDataIndex", {
        get: function () {
            if (this.dataCount) {
                return this.dataCount - 1;
            }
            return this.minCount - 1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Scheduler.prototype, "groupSize", {
        get: function () {
            if (this.loop) {
                return this.minCount;
            }
            if (this.dataCount <= this.minCount)
                return this.dataCount;
            // [开始新增点， 结束新增点]
            var overCount = this.dataCount % this.minCount;
            var maxGroupSize = overCount + this.minCount;
            var maxCount = this.minMiddleCount + 1;
            var endIndex = this.dataCount - maxCount - 1;
            var increaseCount = overCount - 1;
            var startIndex = endIndex - increaseCount;
            if (this.dataIndex <= startIndex)
                return this.minCount;
            if (this.dataIndex > startIndex && this.dataIndex <= endIndex) {
                return this.dataIndex - startIndex + this.minCount;
            }
            return maxGroupSize;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Scheduler.prototype, "maxContainerIndex", {
        get: function () {
            if (this.dataCount) {
                return this.groupSize - 1;
            }
            return this.minCount - 1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Scheduler.prototype, "minMiddleCount", {
        get: function () {
            return Math.floor(this.minCount / 2);
        },
        enumerable: false,
        configurable: true
    });
    /**
     * 更新数据总量
     * @param count 总量值
     */
    Scheduler.prototype.updateCount = function (count) {
        this.dataCount = count;
    };
    /**
     * 更新当前数据索引
     * @param index 当前索引值
     */
    Scheduler.prototype.updateIndex = function (index) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var preDataIndex, getIndex;
            return __generator(this, function (_d) {
                preDataIndex = this.dataIndex;
                getIndex = this.loop ? getTargetIndex : getSafeIndex;
                this.dataIndex = getIndex(index, this.maxDataIndex);
                this.setContainerIndex(this.computeContainerIndex());
                if (preDataIndex !== this.dataIndex) {
                    (_a = this.onDataIndexChange) === null || _a === void 0 ? void 0 : _a.call(this, { containerIndex: this.containerIndex, dataIndex: this.dataIndex });
                }
                if (!this.loop && Math.abs(this.dataIndex - preDataIndex) > 1) {
                    (_b = this.onRestart) === null || _b === void 0 ? void 0 : _b.call(this, { containerIndex: this.containerIndex, dataIndex: this.dataIndex });
                }
                if (this.loop && Math.abs(getStepValue(preDataIndex, this.dataIndex, this.maxDataIndex)) > 1) {
                    (_c = this.onRecompute) === null || _c === void 0 ? void 0 : _c.call(this);
                }
                return [2 /*return*/, this.dataIndex];
            });
        });
    };
    Scheduler.prototype.recomputeIndexArr = function () {
        if (!this.dataCount)
            return [];
        this.setContainerIndex(this.computeContainerIndex());
        this.setGroup(this.computeGroup());
        return this.group;
    };
    Scheduler.prototype.computeContainerIndex = function (step) {
        if (this.loop) {
            return getTargetIndex(this.containerIndex + (step || 0), this.maxContainerIndex);
        }
        if (this.dataCount <= this.minCount * 2 - 1)
            return this.dataIndex;
        var overCount = this.dataCount % this.minCount;
        var lastGroupStartDataIndex = this.dataCount - overCount - this.minCount;
        if (this.dataIndex <= lastGroupStartDataIndex)
            return this.dataIndex % this.minCount;
        return this.dataIndex - lastGroupStartDataIndex;
    };
    Scheduler.prototype.setContainerIndex = function (index) {
        var _a;
        var preContainerIndex = this.containerIndex;
        this.containerIndex = index;
        if (preContainerIndex !== index) {
            (_a = this.onContainerIndexChange) === null || _a === void 0 ? void 0 : _a.call(this, { containerIndex: this.containerIndex, dataIndex: this.dataIndex });
        }
        return this.containerIndex;
    };
    Scheduler.prototype.getStepOffset = function (targetIndex) {
        return getStepValue(this.dataIndex, targetIndex, this.maxDataIndex, this.loop);
    };
    Scheduler.prototype.getSafeDataIndex = function (dataIndex) {
        return getSafeIndex(dataIndex, this.maxDataIndex);
    };
    Scheduler.prototype.getDataIndexByStep = function () {
    };
    Scheduler.prototype.getDataIndex = function () {
        return this.dataIndex;
    };
    Scheduler.prototype.getContainerIndex = function () {
        return this.containerIndex;
    };
    Scheduler.prototype.getDataIndexByContainerIndex = function (index) {
        return this.indexMapping.get(index);
    };
    /**
     * 非 `loop` 模式时， 特殊处理第一组数据
     * @private
     */
    Scheduler.prototype.getFirstGroupIndexMapping = function () {
        return new Map(Array(Math.min(this.minCount, this.dataCount)).fill(null).map(function (_, v) { return [v, v]; }));
    };
    /**
     * 非 `loop` 模式时， 特殊处理最后一组数据
     * @returns
     */
    Scheduler.prototype.getLastGroupIndexMapping = function () {
        if (this.dataCount <= this.minCount) {
            return new Map(Array(this.dataCount).fill(null).map(function (_, i) { return [i, i]; }));
        }
        var overCount = this.dataCount % this.minCount;
        var groupSize = this.groupSize;
        var lastGroupStartDataIndex = this.dataCount - overCount - this.minCount;
        var map = new Map();
        for (var i = 0; i < groupSize; i++) {
            var tempMarkIndex = lastGroupStartDataIndex + i;
            map.set(i, tempMarkIndex);
        }
        return map;
    };
    Object.defineProperty(Scheduler.prototype, "isFirstGroup", {
        get: function () {
            return this.dataIndex <= this.minMiddleCount;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Scheduler.prototype, "isLastGroup", {
        get: function () {
            // 开始超出minCount 就是最后一页了
            if (this.dataCount % this.minCount === 0) {
                return this.dataIndex >= this.maxDataIndex - this.minMiddleCount;
            }
            return this.groupSize > this.minCount;
        },
        enumerable: false,
        configurable: true
    });
    Scheduler.prototype.getIndexMapping = function () {
        var _this = this;
        if (!this.loop) {
            if (this.isFirstGroup)
                return this.getFirstGroupIndexMapping();
            if (this.isLastGroup)
                return this.getLastGroupIndexMapping();
        }
        var map = new Map();
        map.set(this.containerIndex, getTargetIndex(this.dataIndex, this.maxDataIndex));
        Array(this.minMiddleCount).fill(null).forEach(function (_, _index) {
            var count = _index + 1;
            // 计算前后位置
            var prevSwiperIndex = getTargetIndex(_this.containerIndex - count, _this.maxContainerIndex);
            var nextSwiperIndex = getTargetIndex(_this.containerIndex + count, _this.maxContainerIndex);
            var prevMarkIndex = getTargetIndex(_this.dataIndex - count, _this.maxDataIndex);
            var nextMarkIndex = getTargetIndex(_this.dataIndex + count, _this.maxDataIndex);
            map.set(prevSwiperIndex, prevMarkIndex);
            map.set(nextSwiperIndex, nextMarkIndex);
        });
        return map;
    };
    Scheduler.prototype.computeGroup = function () {
        var e_1, _a;
        this.indexMapping = this.getIndexMapping();
        var arr = [];
        try {
            for (var _b = __values(this.indexMapping), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
                arr[key] = value;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return arr;
    };
    Scheduler.prototype.setGroup = function (group) {
        this.group = group;
    };
    return Scheduler;
}());

var SwiperScheduler = /** @class */ (function (_super) {
    __extends(SwiperScheduler, _super);
    function SwiperScheduler(params) {
        var _a;
        var _this = _super.call(this, {
            dataCount: ((_a = params.dataSource) === null || _a === void 0 ? void 0 : _a.length) || 0,
            loop: params.loop || false,
            defaultDataIndex: params.defaultMarkIndex,
            minCount: params.minCount || 3,
            onDataIndexChange: function (detail) {
                _this.emitMarkIndexChange(detail);
            },
            onRestart: function (detail) {
                _this.emitRestart(detail);
            },
            onRecompute: function () { return _this.recompute(); },
            onContainerIndexChange: function (detail) {
                _this.emitSwiperIndexChange(detail);
            },
        }) || this;
        _this.markIndexOfDelay = 0;
        _this.source = [];
        _this.setup(params);
        return _this;
    }
    Object.defineProperty(SwiperScheduler.prototype, "circular", {
        get: function () {
            if (this.loop)
                return true;
            // 使用 markIndexOfDelay 的原因是：如果使用 markIndex 及时更新，会导致swiper组件props变更，动画消失
            return this.markIndexOfDelay !== 0 && this.markIndexOfDelay !== this.maxDataIndex;
        },
        enumerable: false,
        configurable: true
    });
    SwiperScheduler.prototype.updateDataSource = function (value) {
        if (fastDeepEqual(value, this.dataSource))
            return this.dataSource;
        this.dataSource = value;
        this.updateCount(this.dataSource.length);
        // return this.emitRestart({
        //   containerIndex: this.getContainerIndex(),
        //   dataIndex: this.getDataIndex()
        // })
        return this.recompute();
    };
    SwiperScheduler.prototype.nextSection = function () {
        return this.offsetSection(1);
    };
    SwiperScheduler.prototype.prevSection = function () {
        return this.offsetSection(-1);
    };
    SwiperScheduler.prototype.setup = function (params) {
        var _a = params.dataSource, dataSource = _a === void 0 ? [] : _a, _b = params.defaultMarkIndex, defaultMarkIndex = _b === void 0 ? 0 : _b, _c = params.loop, loop = _c === void 0 ? false : _c, onSwiperRestart = params.onSwiperRestart, onSwiperIndexChange = params.onSwiperIndexChange, onSwiperSourceChange = params.onSwiperSourceChange, onMarkIndexChange = params.onMarkIndexChange;
        this.dataSource = dataSource;
        this.loop = loop;
        this.setMarkIndex(defaultMarkIndex);
        this.onSwiperRestart = onSwiperRestart;
        this.onSwiperIndexChange = onSwiperIndexChange;
        this.onSwiperSourceChange = onSwiperSourceChange;
        this.onMarkIndexChange = onMarkIndexChange;
        this.recompute();
    };
    /**
     * 判断当前swiperIndex是否是active状态
     * @param index
     */
    SwiperScheduler.prototype.getActiveStatusBySwiperIndex = function (index) {
        var targetMarkIndex = this.indexMapping.get(index);
        return this.markIndexOfDelay === targetMarkIndex;
    };
    SwiperScheduler.prototype.toSection = function (dataIndex) {
        return __awaiter(this, void 0, void 0, function () {
            var step, markIndex, swiperIndex;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        step = this.getStepOffset(dataIndex);
                        if (Math.abs(step) === 1) {
                            return [2 /*return*/, this.offsetSection(step)];
                        }
                        return [4 /*yield*/, this.setMarkIndex(this.getSafeDataIndex(dataIndex))];
                    case 1:
                        markIndex = _a.sent();
                        swiperIndex = this.setSwiperIndex(this.computeContainerIndex());
                        return [2 /*return*/, {
                                swiperIndex: swiperIndex,
                                markIndex: markIndex
                            }];
                }
            });
        });
    };
    SwiperScheduler.prototype.offsetSection = function (step) {
        return __awaiter(this, void 0, void 0, function () {
            var markIndex, swiperIndex;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setMarkIndex(this.getDataIndex() + step)];
                    case 1:
                        markIndex = _a.sent();
                        swiperIndex = this.setSwiperIndex(this.computeContainerIndex(step));
                        return [2 /*return*/, {
                                swiperIndex: swiperIndex,
                                markIndex: markIndex
                            }];
                }
            });
        });
    };
    SwiperScheduler.prototype.emitRestart = function (_a) {
        var _b;
        var containerIndex = _a.containerIndex, dataIndex = _a.dataIndex;
        var source = this.recompute();
        (_b = this.onSwiperRestart) === null || _b === void 0 ? void 0 : _b.call(this, {
            swiperIndex: containerIndex,
            markIndex: dataIndex,
            key: Date.now().toString(36).slice(0, 8),
            source: source
        });
        return source;
    };
    SwiperScheduler.prototype.emitSwiperIndexChange = function (_a) {
        var _b;
        var containerIndex = _a.containerIndex, dataIndex = _a.dataIndex;
        (_b = this.onSwiperIndexChange) === null || _b === void 0 ? void 0 : _b.call(this, {
            swiperIndex: containerIndex,
            markIndex: dataIndex,
        });
    };
    SwiperScheduler.prototype.emitMarkIndexChange = function (_a) {
        var _b;
        var dataIndex = _a.dataIndex;
        (_b = this.onMarkIndexChange) === null || _b === void 0 ? void 0 : _b.call(this, {
            markIndex: dataIndex
        });
    };
    SwiperScheduler.prototype.recompute = function () {
        var _this = this;
        var result = _super.prototype.recomputeIndexArr.call(this);
        var source = result.map(function (index) { return _this.dataSource[index]; });
        this.updateMarkIndexOfDelay();
        this.setSource(source);
        return source;
    };
    SwiperScheduler.prototype.setMarkIndex = function (markIndex) {
        return _super.prototype.updateIndex.call(this, markIndex);
    };
    SwiperScheduler.prototype.setSwiperIndex = function (swiperIndex) {
        return _super.prototype.setContainerIndex.call(this, swiperIndex);
    };
    SwiperScheduler.prototype.setSource = function (source) {
        var _a;
        if (fastDeepEqual(this.source, source))
            return;
        this.source = source;
        (_a = this.onSwiperSourceChange) === null || _a === void 0 ? void 0 : _a.call(this, this.source);
        return this.source;
    };
    SwiperScheduler.prototype.updateMarkIndexOfDelay = function () {
        this.markIndexOfDelay = this.getDataIndex();
    };
    return SwiperScheduler;
}(Scheduler));

/**
 * 最小渲染数量
 */
var minCount = 3;

// based https://github.com/kentcdodds/use-deep-compare-effect/blob/main/src/index.ts
function checkDeps(deps) {
    if (!deps || !deps.length) {
        throw new Error('useDeepCompareEffect should not be used with no dependencies. Use React.useEffect instead.');
    }
    if (deps.every(isPrimitive)) {
        throw new Error('useDeepCompareEffect should not be used with dependencies that are all primitive values. Use React.useEffect instead.');
    }
}
function isPrimitive(val) {
    return val == null || /^[sbn]/.test(typeof val);
}
/**
 * @param value the value to be memoized (usually a dependency list)
 * @returns a memoized version of the value as long as it remains deeply equal
 */
function useDeepCompareMemoize(value) {
    var ref = React__namespace.useRef(value);
    var signalRef = React__namespace.useRef(0);
    if (!fastDeepEqual(value, ref.current)) {
        ref.current = value;
        signalRef.current += 1;
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
    return React__namespace.useMemo(function () { return ref.current; }, [signalRef.current]);
}
function useDeepCompareEffect(callback, dependencies) {
    if (process.env.NODE_ENV !== 'production') {
        checkDeps(dependencies);
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
    return React__namespace.useEffect(callback, useDeepCompareMemoize(dependencies));
}

var useMemoizedFn = function (fn) {
    var ref = React.useRef(fn);
    ref.current = fn;
    // @ts-ignore
    return React.useCallback(function () {
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        var f = ref.current;
        return f === null || f === void 0 ? void 0 : f.apply(void 0, __spread(params));
    }, []);
};

var ENV_TYPE = Taro__default["default"].getEnv();
function LazySwiper(props) {
    var _this = this;
    var _a = props.className, className = _a === void 0 ? '' : _a, style = props.style, vertical = props.vertical, _b = props.defaultIndex, defaultIndex = _b === void 0 ? 0 : _b, dataSource = props.dataSource, _c = props.maxCount, maxCount = _c === void 0 ? 3 : _c, _d = props.loop, loop = _d === void 0 ? false : _d, lazySwiper = props.lazySwiper, _e = props.duration, duration = _e === void 0 ? 500 : _e, _f = props.swiperWait, swiperWait = _f === void 0 ? duration : _f, _swiperItemExtractor = props.swiperItemExtractor, _renderContent = props.renderContent, _keyExtractor = props.keyExtractor, _onChange = props.onChange, _onBeforeChange = props.onBeforeChange, _onAnimationFinish = props.onAnimationFinish;
    var _g = __read(React.useState(false), 2), isAnimating = _g[0], setAnimating = _g[1];
    var _h = __read(React.useState(0), 2), swiperIndex = _h[0], setSwiperIndex = _h[1];
    var _j = __read(React.useState([]), 2), source = _j[0], setSource = _j[1];
    var _k = __read(React.useState('normal'), 2), swiperKey = _k[0], setSwiperKey = _k[1];
    var renderContent = useMemoizedFn(_renderContent);
    var keyExtractor = useMemoizedFn(_keyExtractor);
    var onChange = useMemoizedFn(_onChange);
    var onBeforeChange = useMemoizedFn(_onBeforeChange);
    var onAnimationFinish = useMemoizedFn(_onAnimationFinish);
    var swiperItemExtractor = useMemoizedFn(_swiperItemExtractor);
    var updateSwiperIndex = React.useCallback(function (index) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setSwiperIndex(index);
                    setAnimating(true);
                    if (!(ENV_TYPE === 'WEAPP')) return [3 /*break*/, 2];
                    return [4 /*yield*/, sleep(duration)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    swiperSchedulerRef.current.recompute();
                    return [4 /*yield*/, sleep(Math.floor(swiperWait))];
                case 3:
                    _a.sent();
                    setAnimating(false);
                    return [2 /*return*/];
            }
        });
    }); }, [duration, swiperWait]);
    var swiperSchedulerRef = React.useRef(React.useMemo(function () {
        return new SwiperScheduler({
            defaultMarkIndex: defaultIndex,
            minCount: Math.max(minCount, maxCount),
            loop: loop,
            onSwiperRestart: function (_a) {
                var sIndex = _a.swiperIndex, key = _a.key;
                setSwiperIndex(sIndex);
                setSwiperKey(key);
            },
            onSwiperIndexChange: function (_a) {
                var sIndex = _a.swiperIndex;
                updateSwiperIndex(sIndex);
            },
            onSwiperSourceChange: function (value) {
                setSource(value);
            },
            onMarkIndexChange: function (_a) {
                var markIndex = _a.markIndex;
                onChange({ current: markIndex });
            },
        });
    }, [defaultIndex, maxCount, loop, updateSwiperIndex, onChange]));
    useDeepCompareEffect(function () {
        setSource(swiperSchedulerRef.current.updateDataSource(dataSource));
    }, [dataSource]);
    var updateSwiperIndexByStep = React.useCallback(function (step) { return __awaiter(_this, void 0, void 0, function () {
        var swiperScheduler;
        return __generator(this, function (_a) {
            swiperScheduler = swiperSchedulerRef.current;
            swiperScheduler.offsetSection(step);
            return [2 /*return*/];
        });
    }); }, []);
    var handleChange = React.useCallback(function (event) {
        var eventIndex = event.detail.current;
        if (swiperIndex === eventIndex)
            return;
        var step = getStepValue(swiperIndex, eventIndex, source.length - 1);
        updateSwiperIndexByStep(step);
    }, [source.length, swiperIndex, updateSwiperIndexByStep]);
    var handleAnimationFinish = React.useCallback(function () {
        var swiperScheduler = swiperSchedulerRef.current;
        onAnimationFinish === null || onAnimationFinish === void 0 ? void 0 : onAnimationFinish({ current: swiperScheduler.getDataIndex() });
    }, [onAnimationFinish]);
    var getActiveStatusBySwiperIndex = React.useCallback(function (index) {
        return swiperSchedulerRef.current.getActiveStatusBySwiperIndex(index);
    }, []);
    var getDataIndexByContainerIndex = React.useCallback(function (index) {
        return swiperSchedulerRef.current.getDataIndexByContainerIndex(index);
    }, []);
    var canNext = React.useCallback(function (targetIndex, callback, payload) { return __awaiter(_this, void 0, void 0, function () {
        var swiperScheduler, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    swiperScheduler = swiperSchedulerRef.current;
                    return [4 /*yield*/, onBeforeChange({ fromIndex: swiperScheduler.getDataIndex(), toIndex: targetIndex, payload: payload })];
                case 1:
                    result = _a.sent();
                    if (result === false)
                        return [2 /*return*/];
                    callback();
                    return [2 /*return*/];
            }
        });
    }); }, [onBeforeChange]);
    var nextSection = React.useCallback(function (payload) {
        if (payload === void 0) { payload = {}; }
        var swiperScheduler = swiperSchedulerRef.current;
        var targetIndex = swiperScheduler.getDataIndex() + 1;
        canNext(targetIndex, function () {
            updateSwiperIndexByStep(1);
        }, payload);
    }, [updateSwiperIndexByStep]);
    var prevSection = React.useCallback(function (payload) {
        if (payload === void 0) { payload = {}; }
        var swiperScheduler = swiperSchedulerRef.current;
        var targetIndex = swiperScheduler.getDataIndex() - 1;
        canNext(targetIndex, function () {
            updateSwiperIndexByStep(-1);
        }, payload);
    }, [updateSwiperIndexByStep]);
    var toSection = React.useCallback(function (index, payload) {
        if (payload === void 0) { payload = {}; }
        return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                canNext(index, function () {
                    swiperSchedulerRef.current.toSection(index);
                }, payload);
                return [2 /*return*/];
            });
        });
    }, [canNext]);
    React.useEffect(function () {
        if (!lazySwiper)
            return;
        Object.assign(lazySwiper, {
            nextSection: nextSection,
            prevSection: prevSection,
            toSection: toSection
        });
    }, [lazySwiper, nextSection, prevSection, toSection]);
    return (React__default["default"].createElement(components.View, { className: "lazy-swiper " + className, style: style },
        React__default["default"].createElement(components.Swiper, { className: 'swiper', key: swiperKey, current: swiperIndex, onChange: handleChange, vertical: vertical, circular: swiperSchedulerRef.current.circular, duration: duration, onAnimationEnd: handleAnimationFinish }, source.map(function (item, index) {
            if (!item)
                return;
            var isActive = getActiveStatusBySwiperIndex(index);
            var dataIndex = getDataIndexByContainerIndex(index);
            var swiperItemProps = swiperItemExtractor(item, dataIndex) || {};
            var key = keyExtractor(item, dataIndex) || index.toString();
            return (React__default["default"].createElement(components.SwiperItem, __assign({}, swiperItemProps, { key: key }), renderContent(item, { key: key, isActive: isActive })));
        })),
        isAnimating ? (React__default["default"].createElement(components.View, { className: 'mask' })) : null));
}

var useLazySwiper = function () {
    var ref = React.useRef({
        nextSection: function () {
        },
        prevSection: function () {
        },
        toSection: function () {
        }
    });
    return [ref.current];
};

exports["default"] = LazySwiper;
exports.useLazySwiper = useLazySwiper;
